/*-
 * ~~~~~~licensing~~~~~~
 * system-api
 * ==========
 * Copyright (C) 2020 - 2024 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.jpa;

import ru.entaxy.esb.system.jpa.entity.ExportAllowed;
import ru.entaxy.esb.system.jpa.entity.System;
import ru.entaxy.esb.system.management.bundle.jpa.entity.BundleEntity;

import java.util.Date;
import java.util.List;
import java.util.Optional;

/**
 * Simple interface systemRegistry service.
 */
public interface SystemService {

    List<System> getSystemList();

    List<System> getFullSystemListByOriginIsEmpty();

    List<System> getFullSystemListByPermissionBySubject(String uuid);

    List<System> getFullSystemListByPermissionByObject(String uuid);

    List<System> getFullSystemListByNotOrigin();

    System get(long id);

    System getByUuid(String uuid);

    System getByName(String name);

    Optional<System> fetch(long id);

    Optional<System> fetchByUuid(String uuid);

    Optional<System> fetchByName(String name);

    System create(System system);

    System setBundleEntity(System system, BundleEntity bundleEntity);

    System saveOrUpdate(System system);

    ExportAllowed addExportAllowed(System system, String exportAllowed);

    System saveOrUpdate(String systemName, String uuid, String description, Date createDate, Date editDate,
                        String createdBy, String editedBy, String version, String type);

    void remove(long id);

    void remove(System system);

    void removeExportAllowed(System system, String esbName);

}
